# Ingress for Provisioning Nexus on /provision.
#
# Motivation: Nexus provides REST APIs on /service. These APIs cannot be used via the default Ingress, because it would redirect to KeyCloak. 
#
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: nexus-provision-rewrite
  namespace: "{{ config.nexus.namespace }}"
  annotations:
    kubernetes.io/ingress.class: nginx
    nginx.ingress.kubernetes.io/proxy-request-buffering: "off"
    # Using 'nginx.ingress.kubernetes.io/rewrite-target: /service/$1' results in too early decoded urlencoded paths,
    # which is a problem in some API calls like updating a role 'Realmgroup:/some-role-name'.
    nginx.ingress.kubernetes.io/configuration-snippet: |
      if ($request_uri ~ "^/provision(/.*)") {
        proxy_pass http://upstream_balancer/service$1;
        break;
      }
spec:
  rules:
  - host: "{{ config.nexus.fqdn }}"
    http:
      paths:
      - backend:
          service: 
            name: nexus-nexus-repository-manager
            port: 
              number: 8081
        path: /provision/
        pathType: Prefix
  tls:
  - hosts:
    - "{{ config.nexus.fqdn }}"
    secretName:  "{{ config.nexus.tls_secret_name | default() }}"
